// Code generated by MockGen. DO NOT EDIT.
// Source: k8s.io/client-go/util/workqueue (interfaces: RateLimitingInterface)
//
// Generated by this command:
//
//	mockgen -typed -destination workqueue.go -package mock_k8s -mock_names RateLimitingInterface=MockRateLimitingWorkqueue k8s.io/client-go/util/workqueue RateLimitingInterface
//

// Package mock_k8s is a generated GoMock package.
package mock_k8s

import (
	reflect "reflect"
	time "time"

	gomock "go.uber.org/mock/gomock"
)

// MockRateLimitingWorkqueue is a mock of RateLimitingInterface interface.
type MockRateLimitingWorkqueue struct {
	ctrl     *gomock.Controller
	recorder *MockRateLimitingWorkqueueMockRecorder
}

// MockRateLimitingWorkqueueMockRecorder is the mock recorder for MockRateLimitingWorkqueue.
type MockRateLimitingWorkqueueMockRecorder struct {
	mock *MockRateLimitingWorkqueue
}

// NewMockRateLimitingWorkqueue creates a new mock instance.
func NewMockRateLimitingWorkqueue(ctrl *gomock.Controller) *MockRateLimitingWorkqueue {
	mock := &MockRateLimitingWorkqueue{ctrl: ctrl}
	mock.recorder = &MockRateLimitingWorkqueueMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockRateLimitingWorkqueue) EXPECT() *MockRateLimitingWorkqueueMockRecorder {
	return m.recorder
}

// Add mocks base method.
func (m *MockRateLimitingWorkqueue) Add(arg0 any) {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "Add", arg0)
}

// Add indicates an expected call of Add.
func (mr *MockRateLimitingWorkqueueMockRecorder) Add(arg0 any) *MockRateLimitingWorkqueueAddCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Add", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).Add), arg0)
	return &MockRateLimitingWorkqueueAddCall{Call: call}
}

// MockRateLimitingWorkqueueAddCall wrap *gomock.Call
type MockRateLimitingWorkqueueAddCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueAddCall) Return() *MockRateLimitingWorkqueueAddCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueAddCall) Do(f func(any)) *MockRateLimitingWorkqueueAddCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueAddCall) DoAndReturn(f func(any)) *MockRateLimitingWorkqueueAddCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// AddAfter mocks base method.
func (m *MockRateLimitingWorkqueue) AddAfter(arg0 any, arg1 time.Duration) {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "AddAfter", arg0, arg1)
}

// AddAfter indicates an expected call of AddAfter.
func (mr *MockRateLimitingWorkqueueMockRecorder) AddAfter(arg0, arg1 any) *MockRateLimitingWorkqueueAddAfterCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "AddAfter", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).AddAfter), arg0, arg1)
	return &MockRateLimitingWorkqueueAddAfterCall{Call: call}
}

// MockRateLimitingWorkqueueAddAfterCall wrap *gomock.Call
type MockRateLimitingWorkqueueAddAfterCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueAddAfterCall) Return() *MockRateLimitingWorkqueueAddAfterCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueAddAfterCall) Do(f func(any, time.Duration)) *MockRateLimitingWorkqueueAddAfterCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueAddAfterCall) DoAndReturn(f func(any, time.Duration)) *MockRateLimitingWorkqueueAddAfterCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// AddRateLimited mocks base method.
func (m *MockRateLimitingWorkqueue) AddRateLimited(arg0 any) {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "AddRateLimited", arg0)
}

// AddRateLimited indicates an expected call of AddRateLimited.
func (mr *MockRateLimitingWorkqueueMockRecorder) AddRateLimited(arg0 any) *MockRateLimitingWorkqueueAddRateLimitedCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "AddRateLimited", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).AddRateLimited), arg0)
	return &MockRateLimitingWorkqueueAddRateLimitedCall{Call: call}
}

// MockRateLimitingWorkqueueAddRateLimitedCall wrap *gomock.Call
type MockRateLimitingWorkqueueAddRateLimitedCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueAddRateLimitedCall) Return() *MockRateLimitingWorkqueueAddRateLimitedCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueAddRateLimitedCall) Do(f func(any)) *MockRateLimitingWorkqueueAddRateLimitedCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueAddRateLimitedCall) DoAndReturn(f func(any)) *MockRateLimitingWorkqueueAddRateLimitedCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Done mocks base method.
func (m *MockRateLimitingWorkqueue) Done(arg0 any) {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "Done", arg0)
}

// Done indicates an expected call of Done.
func (mr *MockRateLimitingWorkqueueMockRecorder) Done(arg0 any) *MockRateLimitingWorkqueueDoneCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Done", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).Done), arg0)
	return &MockRateLimitingWorkqueueDoneCall{Call: call}
}

// MockRateLimitingWorkqueueDoneCall wrap *gomock.Call
type MockRateLimitingWorkqueueDoneCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueDoneCall) Return() *MockRateLimitingWorkqueueDoneCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueDoneCall) Do(f func(any)) *MockRateLimitingWorkqueueDoneCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueDoneCall) DoAndReturn(f func(any)) *MockRateLimitingWorkqueueDoneCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Forget mocks base method.
func (m *MockRateLimitingWorkqueue) Forget(arg0 any) {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "Forget", arg0)
}

// Forget indicates an expected call of Forget.
func (mr *MockRateLimitingWorkqueueMockRecorder) Forget(arg0 any) *MockRateLimitingWorkqueueForgetCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Forget", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).Forget), arg0)
	return &MockRateLimitingWorkqueueForgetCall{Call: call}
}

// MockRateLimitingWorkqueueForgetCall wrap *gomock.Call
type MockRateLimitingWorkqueueForgetCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueForgetCall) Return() *MockRateLimitingWorkqueueForgetCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueForgetCall) Do(f func(any)) *MockRateLimitingWorkqueueForgetCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueForgetCall) DoAndReturn(f func(any)) *MockRateLimitingWorkqueueForgetCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Get mocks base method.
func (m *MockRateLimitingWorkqueue) Get() (any, bool) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Get")
	ret0, _ := ret[0].(any)
	ret1, _ := ret[1].(bool)
	return ret0, ret1
}

// Get indicates an expected call of Get.
func (mr *MockRateLimitingWorkqueueMockRecorder) Get() *MockRateLimitingWorkqueueGetCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Get", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).Get))
	return &MockRateLimitingWorkqueueGetCall{Call: call}
}

// MockRateLimitingWorkqueueGetCall wrap *gomock.Call
type MockRateLimitingWorkqueueGetCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueGetCall) Return(arg0 any, arg1 bool) *MockRateLimitingWorkqueueGetCall {
	c.Call = c.Call.Return(arg0, arg1)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueGetCall) Do(f func() (any, bool)) *MockRateLimitingWorkqueueGetCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueGetCall) DoAndReturn(f func() (any, bool)) *MockRateLimitingWorkqueueGetCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// Len mocks base method.
func (m *MockRateLimitingWorkqueue) Len() int {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Len")
	ret0, _ := ret[0].(int)
	return ret0
}

// Len indicates an expected call of Len.
func (mr *MockRateLimitingWorkqueueMockRecorder) Len() *MockRateLimitingWorkqueueLenCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Len", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).Len))
	return &MockRateLimitingWorkqueueLenCall{Call: call}
}

// MockRateLimitingWorkqueueLenCall wrap *gomock.Call
type MockRateLimitingWorkqueueLenCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueLenCall) Return(arg0 int) *MockRateLimitingWorkqueueLenCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueLenCall) Do(f func() int) *MockRateLimitingWorkqueueLenCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueLenCall) DoAndReturn(f func() int) *MockRateLimitingWorkqueueLenCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// NumRequeues mocks base method.
func (m *MockRateLimitingWorkqueue) NumRequeues(arg0 any) int {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "NumRequeues", arg0)
	ret0, _ := ret[0].(int)
	return ret0
}

// NumRequeues indicates an expected call of NumRequeues.
func (mr *MockRateLimitingWorkqueueMockRecorder) NumRequeues(arg0 any) *MockRateLimitingWorkqueueNumRequeuesCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "NumRequeues", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).NumRequeues), arg0)
	return &MockRateLimitingWorkqueueNumRequeuesCall{Call: call}
}

// MockRateLimitingWorkqueueNumRequeuesCall wrap *gomock.Call
type MockRateLimitingWorkqueueNumRequeuesCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueNumRequeuesCall) Return(arg0 int) *MockRateLimitingWorkqueueNumRequeuesCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueNumRequeuesCall) Do(f func(any) int) *MockRateLimitingWorkqueueNumRequeuesCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueNumRequeuesCall) DoAndReturn(f func(any) int) *MockRateLimitingWorkqueueNumRequeuesCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// ShutDown mocks base method.
func (m *MockRateLimitingWorkqueue) ShutDown() {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "ShutDown")
}

// ShutDown indicates an expected call of ShutDown.
func (mr *MockRateLimitingWorkqueueMockRecorder) ShutDown() *MockRateLimitingWorkqueueShutDownCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ShutDown", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).ShutDown))
	return &MockRateLimitingWorkqueueShutDownCall{Call: call}
}

// MockRateLimitingWorkqueueShutDownCall wrap *gomock.Call
type MockRateLimitingWorkqueueShutDownCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueShutDownCall) Return() *MockRateLimitingWorkqueueShutDownCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueShutDownCall) Do(f func()) *MockRateLimitingWorkqueueShutDownCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueShutDownCall) DoAndReturn(f func()) *MockRateLimitingWorkqueueShutDownCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// ShutDownWithDrain mocks base method.
func (m *MockRateLimitingWorkqueue) ShutDownWithDrain() {
	m.ctrl.T.Helper()
	m.ctrl.Call(m, "ShutDownWithDrain")
}

// ShutDownWithDrain indicates an expected call of ShutDownWithDrain.
func (mr *MockRateLimitingWorkqueueMockRecorder) ShutDownWithDrain() *MockRateLimitingWorkqueueShutDownWithDrainCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ShutDownWithDrain", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).ShutDownWithDrain))
	return &MockRateLimitingWorkqueueShutDownWithDrainCall{Call: call}
}

// MockRateLimitingWorkqueueShutDownWithDrainCall wrap *gomock.Call
type MockRateLimitingWorkqueueShutDownWithDrainCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueShutDownWithDrainCall) Return() *MockRateLimitingWorkqueueShutDownWithDrainCall {
	c.Call = c.Call.Return()
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueShutDownWithDrainCall) Do(f func()) *MockRateLimitingWorkqueueShutDownWithDrainCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueShutDownWithDrainCall) DoAndReturn(f func()) *MockRateLimitingWorkqueueShutDownWithDrainCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}

// ShuttingDown mocks base method.
func (m *MockRateLimitingWorkqueue) ShuttingDown() bool {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ShuttingDown")
	ret0, _ := ret[0].(bool)
	return ret0
}

// ShuttingDown indicates an expected call of ShuttingDown.
func (mr *MockRateLimitingWorkqueueMockRecorder) ShuttingDown() *MockRateLimitingWorkqueueShuttingDownCall {
	mr.mock.ctrl.T.Helper()
	call := mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ShuttingDown", reflect.TypeOf((*MockRateLimitingWorkqueue)(nil).ShuttingDown))
	return &MockRateLimitingWorkqueueShuttingDownCall{Call: call}
}

// MockRateLimitingWorkqueueShuttingDownCall wrap *gomock.Call
type MockRateLimitingWorkqueueShuttingDownCall struct {
	*gomock.Call
}

// Return rewrite *gomock.Call.Return
func (c *MockRateLimitingWorkqueueShuttingDownCall) Return(arg0 bool) *MockRateLimitingWorkqueueShuttingDownCall {
	c.Call = c.Call.Return(arg0)
	return c
}

// Do rewrite *gomock.Call.Do
func (c *MockRateLimitingWorkqueueShuttingDownCall) Do(f func() bool) *MockRateLimitingWorkqueueShuttingDownCall {
	c.Call = c.Call.Do(f)
	return c
}

// DoAndReturn rewrite *gomock.Call.DoAndReturn
func (c *MockRateLimitingWorkqueueShuttingDownCall) DoAndReturn(f func() bool) *MockRateLimitingWorkqueueShuttingDownCall {
	c.Call = c.Call.DoAndReturn(f)
	return c
}
